BEGIN;

drop type user_gender;

CREATE TYPE "user_gender" AS ENUM (
  'male',
  'female'
);

CREATE TABLE "user_role" (
  "id" BIGINT GENERATED BY DEFAULT AS IDENTITY PRIMARY KEY NOT NULL,
  "name" varchar NOT NULL,
  "created_at" timestamptz DEFAULT null,
  "updated_at" timestamptz DEFAULT null,
  "deleted_at" timestamptz DEFAULT null,
  "created_by" bigint DEFAULT null,
  "updated_by" bigint DEFAULT null,
  "deleted_by" bigint DEFAULT null
);

CREATE TABLE "user" (
  "id" BIGINT GENERATED BY DEFAULT AS IDENTITY PRIMARY KEY NOT NULL,
  "name" varchar NOT NULL,
  "password" varchar NOT NULL,
  "avatar" varchar DEFAULT null,
  "gender" user_gender DEFAULT 'male',
  "created_at" timestamptz DEFAULT null,
  "updated_at" timestamptz DEFAULT null,
  "deleted_at" timestamptz DEFAULT null,
  "created_by" bigint DEFAULT null,
  "updated_by" bigint DEFAULT null,
  "deleted_by" bigint DEFAULT null
);

CREATE TABLE "user_role_map" (
  "id" BIGINT GENERATED BY DEFAULT AS IDENTITY PRIMARY KEY NOT NULL,
  "user_id" bigint NOT NULL,
  "user_role_id" bigint NOT NULL,
  "created_at" timestamptz DEFAULT null,
  "updated_at" timestamptz DEFAULT null,
  "deleted_at" timestamptz DEFAULT null,
  "created_by" bigint DEFAULT null,
  "updated_by" bigint DEFAULT null,
  "deleted_by" bigint DEFAULT null
);

CREATE TABLE "user_email" (
  "id" BIGINT GENERATED BY DEFAULT AS IDENTITY PRIMARY KEY NOT NULL,
  "user_id" bigint NOT NULL,
  "email" varchar UNIQUE NOT NULL,
  "default" bool DEFAULT false,
  "created_at" timestamptz DEFAULT null,
  "updated_at" timestamptz DEFAULT null,
  "deleted_at" timestamptz DEFAULT null,
  "created_by" bigint DEFAULT null,
  "updated_by" bigint DEFAULT null,
  "deleted_by" bigint DEFAULT null
);

CREATE TABLE "user_phone" (
  "id" BIGINT GENERATED BY DEFAULT AS IDENTITY PRIMARY KEY NOT NULL,
  "user_id" bigint NOT NULL,
  "phone" varchar UNIQUE NOT NULL,
  "default" bool DEFAULT false,
  "created_at" timestamptz DEFAULT null,
  "updated_at" timestamptz DEFAULT null,
  "deleted_at" timestamptz DEFAULT null,
  "created_by" bigint DEFAULT null,
  "updated_by" bigint DEFAULT null,
  "deleted_by" bigint DEFAULT null
);

CREATE TABLE "user_address" (
  "id" BIGINT GENERATED BY DEFAULT AS IDENTITY PRIMARY KEY NOT NULL,
  "user_id" bigint NOT NULL,
  "address" varchar NOT NULL,
  "long" varchar DEFAULT null,
  "lat" varchar DEFAULT null,
  "default" bool DEFAULT false,
  "created_at" timestamptz DEFAULT null,
  "updated_at" timestamptz DEFAULT null,
  "deleted_at" timestamptz DEFAULT null,
  "created_by" bigint DEFAULT null,
  "updated_by" bigint DEFAULT null,
  "deleted_by" bigint DEFAULT null
);

CREATE TABLE "user_menu" (
  "id" BIGINT GENERATED BY DEFAULT AS IDENTITY PRIMARY KEY NOT NULL,
  "name" varchar UNIQUE NOT NULL,
  "icon" varchar DEFAULT null,
  "path" varchar DEFAULT null,
  "separator" bool DEFAULT false,
  "header" bool DEFAULT false,
  "key" int UNIQUE DEFAULT 1,
  "key_group" int DEFAULT 1,
  "level" int DEFAULT 1,
  "order" int DEFAULT 1,
  "option_view" bool DEFAULT false,
  "option_create" bool DEFAULT false,
  "option_update" bool DEFAULT false,
  "option_delete" bool DEFAULT false,
  "option_import" bool DEFAULT false,
  "option_export" bool DEFAULT false,
  "option_approval" bool DEFAULT false,
  "created_at" timestamptz DEFAULT null,
  "updated_at" timestamptz DEFAULT null,
  "deleted_at" timestamptz DEFAULT null,
  "created_by" bigint DEFAULT null,
  "updated_by" bigint DEFAULT null,
  "deleted_by" bigint DEFAULT null
);

CREATE TABLE "user_role_menu" (
  "id" BIGINT GENERATED BY DEFAULT AS IDENTITY PRIMARY KEY NOT NULL,
  "user_role_id" bigint NOT NULL,
  "user_menu_id" bigint NOT NULL,
  "access_view" bool DEFAULT false,
  "access_create" bool DEFAULT false,
  "access_update" bool DEFAULT false,
  "access_delete" bool DEFAULT false,
  "access_import" bool DEFAULT false,
  "access_export" bool DEFAULT false,
  "access_approval" bool DEFAULT false,
  "created_at" timestamptz DEFAULT null,
  "updated_at" timestamptz DEFAULT null,
  "deleted_at" timestamptz DEFAULT null,
  "created_by" bigint DEFAULT null,
  "updated_by" bigint DEFAULT null,
  "deleted_by" bigint DEFAULT null
);

COMMENT ON COLUMN "user"."gender" IS 'male or female';

COMMENT ON COLUMN "user_email"."email" IS 'email unique';

COMMENT ON COLUMN "user_phone"."phone" IS 'phone unique, ex : +6285694462012';

COMMENT ON COLUMN "user_menu"."name" IS 'name unique';

COMMENT ON COLUMN "user_menu"."key" IS 'ex : 1,2,3,4,5,6,7,8,9';

COMMENT ON COLUMN "user_menu"."key_group" IS 'ex : 1,2,3,4,5,6,7,8,9';

COMMENT ON COLUMN "user_menu"."level" IS 'ex : 1,2,3,4';

COMMENT ON COLUMN "user_menu"."order" IS 'ex : 1,2,3,4';

ALTER TABLE "user_role_map" ADD FOREIGN KEY ("user_id") REFERENCES "user" ("id");

ALTER TABLE "user_role_map" ADD FOREIGN KEY ("user_role_id") REFERENCES "user_role" ("id");

ALTER TABLE "user_email" ADD FOREIGN KEY ("user_id") REFERENCES "user" ("id");

ALTER TABLE "user_phone" ADD FOREIGN KEY ("user_id") REFERENCES "user" ("id");

ALTER TABLE "user_address" ADD FOREIGN KEY ("user_id") REFERENCES "user" ("id");

ALTER TABLE "user_role_menu" ADD FOREIGN KEY ("user_role_id") REFERENCES "user_role" ("id");

ALTER TABLE "user_role_menu" ADD FOREIGN KEY ("user_menu_id") REFERENCES "user_menu" ("id");

COMMIT;